
#include "../ringbuffer.hpp"
#include "../bufferio.hpp"
using namespace bufferlib;

#include <iostream>
using namespace std;

#define PRINT_STATS() \
	cout << "CanReadMin: " << ringbuffer.can_read_min() << " \tO1: " << output1->position() << " \tO2: " << output2->position() << endl; \
	cout << "CanWriteMin: " << ringbuffer.can_write_min() << " \tI1: " << input1->position() << endl << endl; enum{}

int main()
{
	ringbuffer_t<char> ringbuffer(40);
	boost::shared_ptr< input_t<char> > input1;
	boost::shared_ptr< output_t<char> > output1;
	boost::shared_ptr< output_t<char> > output2;
	char buffer1[1024];
	char buffer2_1[1024];
	char buffer2_2[1024];
	count_t len;

	input1 = boost::shared_ptr< input_t<char> >(new input_t<char>(&ringbuffer));
	output1 = boost::shared_ptr< output_t<char> >(new output_t<char>(&ringbuffer));
	output2 = boost::shared_ptr< output_t<char> >(new output_t<char>(&ringbuffer));
	ringbuffer.add_input(input1);
	ringbuffer.add_output(output1);
	ringbuffer.add_output(output2);

	PRINT_STATS();

	cout << "input1->write: " << input1->write("abcdefghijklmnopqrstuvwxyz",string("abcdefghijklmnopqrstuvwxyz").size()) << endl;

	PRINT_STATS();

	cout << "output2->read: " << (len=output2->read(buffer2_1,10)) << endl;
	buffer2_1[len]=0;
	cout << "Buffer2_1: " << buffer2_1 << endl;

	PRINT_STATS();

	cout << "input1->write: " << input1->write("abcdefghijklmnopqrstuvwxyz",string("abcdefghijklmnopqrstuvwxyz").size()) << endl;

	PRINT_STATS();

	cout << "output2->read: " << (len=output2->read(buffer2_2,40)) << endl;
	buffer2_2[len]=0;
	cout << "Buffer2_2: " << buffer2_2 << endl;

	PRINT_STATS();

	cout << "output1->read: " << (len=output1->read(buffer1,31)) << endl;
	buffer1[len]=0;
	cout << "Buffer1: " << buffer1 << endl;

	PRINT_STATS();

	cout << "input1->write: " << input1->write("abcdefghijklmnopqrstuvwxyz",string("abcdefghijklmnopqrstuvwxyz").size()) << endl;

	PRINT_STATS();

	cout << "output2->read: " << (len=output2->read(buffer2_1,12)) << endl;
	buffer2_1[len]=0;
	cout << "Buffer2_1: " << buffer2_1 << endl;

	PRINT_STATS();

	cout << "input1->write: " << input1->write("abcdefghijklmnopqrstuvwxyz",string("abcdefghijklmnopqrstuvwxyz").size()) << endl;

	PRINT_STATS();

	cout << "output2->read: " << (len=output2->read(buffer2_2,36)) << endl;
	buffer2_2[len]=0;
	cout << "Buffer2_2: " << buffer2_2 << endl;

	PRINT_STATS();

	cout << "output1->read: " << (len=output1->read(buffer1,13)) << endl;
	buffer1[len]=0;
	cout << "Buffer1: " << buffer1 << endl;

	PRINT_STATS();

	return 0;
}
